<template>
  <div class="gpa-library__content">
    <rui-panel resize="right">
      <gpa-library-filters v-model="filters" />
    </rui-panel>

    <rui-panel resize="right" class="gpa-library__list-panel">
      <rui-search-form v-model="searchTerm" />
      <rui-empty v-show="resources.length === 0" class="-pd" icon-size="4">
        {{ $t('js.library.no_resource_to_display') }}
        <rui-button :caption="$t('js.library.reset_filters')" class="-mtd" block @click="resetFilters" />
      </rui-empty>
      <recycle-scroller v-slot="{item}"
                        key-field="id"
                        class="_virtual-scroll-area"
                        :items="resources"
                        :item-size="48">
        <rui-list-item :active="item.id === selectedResourceId"
                       :sub-caption="item.latinName"
                       :image="item.picturePath"
                       :icon="item.generic? 'generic' : null"
                       :to="{params: {resourceId: item.id}}">
          <rui-icon v-if="item.generic" name="generic" /> {{ item.name }}
        </rui-list-item>
      </recycle-scroller>
    </rui-panel>
    <div class="gpa-library__content__resource">
      <rui-alert v-if="!selectedResource" variant="mute">{{ $t('js.genera.index.no_selected_resource') }}</rui-alert>
      <div v-else>
        <gpa-resource-description-area :resource="selectedResource" :show-links="true" />
      </div>
    </div>
  </div>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiSearchForm from '@experiments-labs/rise_ui/src/components/Form/SearchForm.vue'
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'
import RuiPanel from '@experiments-labs/rise_ui/src/components/Panel/Panel.vue'

import GpaResourceDescriptionArea from './Resources/_Resource.vue'
import GpaLibraryFilters from './Library/Filters.vue'

/**
 * Generates default filters set, to bbe used in initialization or resets.
 *
 * @returns {object} - Empty filters set
 */
function defaultFilters () {
  return {
    generic: false,
    tags: [],
    shelteredSowingMonths: [],
    soilSowingMonths: [],
    harvestingMonths: [],
    cropRotationGroups: [],
  }
}

export default {
  name: 'GpaLibrary',
  components: {
    RuiButton,
    RuiEmpty,
    RuiAlert,
    RuiIcon,
    RuiListItem,
    RuiSearchForm,
    RuiPanel,
    GpaLibraryFilters,
    GpaResourceDescriptionArea,
  },
  data () {
    return {
      selectedResourceId: null,
      searchTerm: '',
      filters: defaultFilters(),
    }
  },
  computed: {
    resources () {
      const options = {
        generic: this.filters.generic,
        search: this.searchTerm,
        tags: this.filters.tags,
        shelteredSowingMonths: this.filters.shelteredSowingMonths,
        soilSowingMonths: this.filters.soilSowingMonths,
        harvestingMonths: this.filters.harvestingMonths,
        cropRotationGroups: this.filters.cropRotationGroups,
      }
      return this.$store.getters.searchedAndFilteredResources(options)
    },
    selectedResource () { return this.$store.getters.resource(this.selectedResourceId) },
  },
  methods: {
    setSelectedResourceId () {
      const id = this.$route.params.resourceId
      this.selectedResourceId = id ? parseInt(id, 10) : null
    },
    resetFilters () {
      const filters = defaultFilters()
      Object.keys(filters).forEach(key => { this.filters[key] = filters[key] })
    },
  },
  created () {
    this.setSelectedResourceId()
  },
  watch: {
    $route () {
      this.setSelectedResourceId()
    },
  },
}
</script>
